Config                      = {}
Config.DrawDistance         = 8.0
Config.MarkerType           = 27
Config.MarkerSize           = {x = 4.75, y = 4.75, z = 0.45}
Config.MarkerColor          = {r = 17, g = 255, b = 0}
Config.MinimumHealth 		= 850.0
Config.ImpoundPrice			= 5000
Config.MaxSubs				= 1
Config.ReceiveMsg = true
Config.EnableBlips = true 



Config.Locale = 'pl'

Config.Garages = {
	-- BLIP
	{
		Marker  = vector3(-926.21, -164.11, 40.98),
		Blip	= true,
		Visible = {}
	},
	{
		Marker  = vector3(-1081.35, -2597.41, 12.75),
		Blip	= true,
		Visible = {}
	},
	{
		Marker 	= vector3(-1173.18, -739.67, 19.04),
		Blip	= true,
		Visible = {}
	},
	{
		Marker 	= vector3(385.51, -1657.58, 26.4),
		Blip	= true,
		Visible = {}
	},
	{
		Marker 	= vector3(-1530.76, 84.22, 55.85),
		Blip	= false, --playboy
		Visible = {}
	},
	{
		Marker 	= vector3(1420.08, -1506.79, 60.05),
		Blip	= false, --marabunta
		Visible = {}
	},

	{
		Marker 	= vector3(235.01, -784.24, 29.74),
		Blip	= true,
		Visible = {}
	},
	{
		Marker 	= vector3(612.92, 95.05, 91.55),
		Blip	= true,
		Visible = {}
	},
	{
		Marker 	= vector3(1467.12, 3740.12, 32.68),
		Blip	= true,
		Visible = {}
	},
	{
		Marker 	= vector3(10.16, 6332.0, 30.34),
		Blip	= true,
		Visible = {}
	},
	{
		Marker 	= vector3(-1194.04, -1490.86, 3.48),
		Blip	= true,
		Visible = {}
	},
	{
		Marker 	= vector3(-3146.04, 1091.1, 19.79),
		Blip	= true,
		Visible = {}
	},
	{
		Marker 	= vector3(1688.43, 4774.03, 41.02),
		Blip	= true,
		Visible = {}
	},
	{
		Marker 	= vector3(572.16, 2724.44, 41.16),
		Blip = true,
		Visible = {}
	},
	{
		Marker  = vector3(30.98, -860.97, 29.67),
		Blip	= true,
		Visible = {}
	},
	{
		Marker  = vector3(934.87, -1.06, 77.86),
		Blip	= true,
		Visible = {}
	},
	{
		Marker  = vector3(405.05, -1278.6, 29.37),
		Blip	= true,
		Visible = {}
	},
	{
		Marker  = vector3(-1879.58, -308.17, 48.34),
		Blip	= true,
		Visible = {}
	},
	{
		Marker  = vector3(2769.66, 3467.82, 54.66),
		Blip	= true,
		Visible = {}
	},
	{
		Marker  = vector3(333.21, -2038.74, 20.15),
		Blip	= true,
		Visible = {}
	},
	{
		Marker  = vector3(1144.02, -3244.63, 5.0),
		Blip	= true,
		Visible = {}
	},
	{
		Marker  = vector3(1004.04, -2336.67, 29.61),
		Blip	= true,
		Visible = {}
	},
	{
		Marker  = vector3(-334.79, -751.01, 33.07),
		Blip	= true,
		Visible = {}
	},
	{
		Marker  = vector3(-1635.5, -891.93, 8.05),
		Blip	= true,
		Visible = {}
	},
	{
		Marker  = vector3(-1392.48, 80.49, 52.95),
		Blip	= true,
		Visible = {}
	},
	{
		Marker  = vector3(-583.91, 315.77, 84.0),
		Blip	= true,
		Visible = {}
	},
	{
		Marker  = vector3(-498.54, 57.09, 55.6),
		Blip	= true,
		Visible = {}
	},
	{
		Marker  = vector3(-92.24, 80.85, 70.7),
		Blip	= true,
		Visible = {}
	},
	{
		Marker  = vector3(-801.08, -1305.94, 4.1),
		Blip	= true,
		Visible = {}
	},
	{
		Marker  = vector3(-2973.64, 70.09, 10.71),
		Blip	= true,
		Visible = {}
	},
	{
		Marker  = vector3(2587.52, 419.76, 107.56),
		Blip	= true,
		Visible = {}
	},
	{
		Marker  = vector3(273.85, -331.33, 44.02),
		Blip	= true,
		Visible = {}
	},
	-- NO BLIP
	{
		Marker 	= vector3(-795.99, 319.41, 84.78),
		Blip	= false,
		Visible = {}
	},
	{
		Marker 	= vector3(268.61, -994.84, 28.70),
		Blip	= false,
		Visible = {}
	},
	{
		Marker 	= vector3(493.92, -1331.52, 28.34),
		Blip	= false,
		Visible = {}
	},
	{
		Marker 	= vector3(412.27, -1635.87, 28.29),
		Blip	= false,
		Visible = {}
	},
	{
		Marker  = vector3(-1039.03, -2714.28, 12.9),
		Blip	= false,
		Visible = {}
	},
	{
		Marker  = vector3(462.73, -1035.32, 27.51),
		Blip	= false,
		Visible = {}
	},
	{
		Marker  = vector3(-35.35, -616.47, 34.18),
		Blip	= false,
		Visible = {}
	},
	{
		Marker  = vector3(-1039.03, -2714.28, 12.9),
		Blip	= false,
		Visible = {}
	},
	{
		Marker  = vector3(-1467.69, -504.56, 31.91),
		Blip	= false,
		Visible = {}
	},
	{
		Marker  = vector3(-1032.12, -2730.32, 19.30),
		Blip	= false,
		Visible = {}
	},
	{
		Marker  = vector3(-626.1, 56.4, 42.83),
		Blip	= false,
		Visible = {}
	},
	{
		Marker  = vector3(-893.9, -344.26, 33.63),
		Blip	= false,
		Visible = {}
	},
	{
		Marker  = vector3(-1039.03, -2714.28, 12.9),
		Blip	= false,
		Visible = {}
	},
	{
		Marker  = vector3(1855.43, 2590.98, 44.77),
		Blip	= false,
		Visible = {}
	},
	{
		Marker 	= vector3(327.66, -205.42, 53.19),
		Blip	= false,
		Visible = {}
	},
	{
		Marker 	= vector3(320.75, -547.24, 27.84),
		Blip	= false,
		Visible = {}
	},
	{
		Marker  = vector3(219.75, -778.22, 29.9),
		Blip	= false,
		Visible = {}
	},
	{
		Marker  = vector3(-832.17, -394.01, 30.42),
		Blip	= false,
		Visible = {}
	},
	{
		Marker  = vector3(-699.79, 312.31, 82),
		Blip	= false,
		Visible = {}
	},
	{
		Marker  = vector3(78.14, -1905.46, 20.51),
		Blip	= false,
		Visible = {}
        },
	{
		Marker  = vector3(-586.79, -1601.76, 26.56),
		Blip	= false,
		Visible = {}


	},
	-- JOBS
	{
		Marker  = vector3(912.27, -952.84, 38.6),
		Blip	= false,
		Visible = {'mecano', 'offmecano'}
	},
	{
		Marker  = vector3(1867.46, 3683.23, 32.79),
		Blip	= false,
		Visible = {'police', 'offpolice', 'ambulance', 'offambulance'}
	},
	{
		Marker  = vector3(857.73, -933.69, 25.50),
		Blip	= true,
		Visible = {'mechanic', 'offmechanic', 'police', 'offpolice'}
	},
	{
		Marker  = vector3(-271.02, 6334.22, 31.53),
		Blip	= false,
		Visible = {'ambulance', 'offambulance'}
	},
	{
		Marker  = vector3(-465.15, 6033.63, 30.44),
		Blip	= false,
		Visible = {'police', 'offpolice'}
	},
	{
		Marker  = vector3(435.78, -975.92, 24.87),
		Blip	= false,
		Visible = {'police', 'offpolice'}
	},
}

Config.Impound = {
	vector3(495.96, -1339.87, 28.35), --395.81 -1339.87 29.32
	vector3(2052.73, 3192.07, 44.35),
}

Config.PoliceImpound = {
	vector3(485.35, -1096.99, 28.3),
}

Config.SetSubowner = {
	vector3(-267.62, -953.86, 30.35)
	--vector3(245.78, -786.33, 30.52)
}